/*
**	gint:core:vbr - Assembler-level VBR management
*/

.text
.global _cpu_setCPUOPM
.global _cpu_getCPUOPM
.global _cpu_getSR
.global _cpu_setSR
.global	_cpu_setVBR
.global _cpu_getVBR


/* cpu_setCPUOPM(): Change the CPU Operation Mode register */
_cpu_setCPUOPM:
	/* Set CPUOPM as requested */
	mov.l	1f, r0
	mov.l	r4, @r0

	/* Read CPUOPM again */
	mov.l	@r0, r5

	/* Invalidate a cache address */
	mov	#-96, r0
	shll16	r0
	shll8	r0
	icbi	@r0

	rts
	nop

/* cpu_getCPUOPM(): Get the CPU OperatioN Mode register */
_cpu_getCPUOPM:
	mov.l	1f, r0
	rts
	mov.l	@r0, r0

.align 4
1:	.long	0xff2f0000

/* cpu_getSR(): Get status register */
_cpu_getSR:
	stc	sr, r0
	rts
	nop

/* cpu_setSR(): Set status register */
_cpu_setSR:
	ldc	r4, sr
	rts
	nop

/* cpu_setVBR(): Set the VBR */
_cpu_setVBR:
	/* Block all interrupts by setting IMASK=15 */
	mov	#0xf, r1
	shll2	r1
	shll2	r1
	stc	sr, r2
	or	r2, r1
	ldc	r1, sr

	/* switch VBR */
	stc	vbr, r0
	ldc	r4, vbr

	/* resotre old SR */
	ldc	r2, sr
	rts
	nop

/* cpu_getVBR: Get the VBR */
_cpu_getVBR:
	stc	vbr, r0
	rts
	nop
